import { AfterViewInit, OnDestroy } from '@angular/core';
import { IFlagMouse, IPopover, IPopoverFunctionControlEvent, TYPE_POPOVER_EVENT } from '@libs-ui/components-popover';
import { TYPE_SPINNER } from '@libs-ui/components-spinner';
import { IColorButton } from '@libs-ui/services-config-project';
import { TYPE_SIZE_BUTTON } from './interfaces/button.interface';
import * as i0 from "@angular/core";
export declare class LibsUiComponentsButtonsButtonComponent implements AfterViewInit, OnDestroy {
    private onDestroy;
    protected classBinding: import("@angular/core").WritableSignal<string>;
    protected isClick: import("@angular/core").WritableSignal<boolean>;
    protected typeIconLoading: import("@angular/core").WritableSignal<TYPE_SPINNER>;
    protected typeButton: import("@angular/core").WritableSignal<boolean>;
    private configProjectService;
    readonly flagMouse: import("@angular/core").InputSignal<IFlagMouse>;
    readonly type: import("@angular/core").InputSignal<string>;
    readonly buttonCustom: import("@angular/core").InputSignal<IColorButton | undefined>;
    readonly sizeButton: import("@angular/core").InputSignalWithTransform<TYPE_SIZE_BUTTON, TYPE_SIZE_BUTTON | undefined>;
    readonly label: import("@angular/core").InputSignal<string>;
    readonly disable: import("@angular/core").InputSignal<boolean>;
    readonly isPending: import("@angular/core").InputSignal<boolean | undefined>;
    readonly imageLeft: import("@angular/core").InputSignal<{
        src: string;
        classInclude?: string;
    } | undefined>;
    readonly classInclude: import("@angular/core").InputSignal<string>;
    readonly classIconLeft: import("@angular/core").InputSignal<string>;
    readonly classIconRight: import("@angular/core").InputSignal<string>;
    readonly classLabel: import("@angular/core").InputSignal<string>;
    readonly iconOnlyType: import("@angular/core").InputSignal<boolean>;
    readonly popover: import("@angular/core").InputSignal<IPopover>;
    readonly ignoreStopPropagationEvent: import("@angular/core").InputSignalWithTransform<boolean, boolean | undefined>;
    readonly zIndex: import("@angular/core").InputSignal<number>;
    readonly widthLabelPopover: import("@angular/core").InputSignal<number | undefined>;
    readonly styleIconLeft: import("@angular/core").InputSignal<Record<string, any> | undefined>;
    readonly styleButton: import("@angular/core").InputSignal<Record<string, any> | undefined>;
    readonly ignoreFocusWhenInputTab: import("@angular/core").InputSignal<boolean | undefined>;
    readonly ignoreSetClickWhenShowPopover: import("@angular/core").InputSignal<boolean | undefined>;
    readonly ignorePointerEvent: import("@angular/core").InputSignal<boolean | undefined>;
    readonly isActive: import("@angular/core").InputSignal<boolean | undefined>;
    readonly isHandlerEnterDocumentClickButton: import("@angular/core").InputSignal<boolean | undefined>;
    readonly outClick: import("@angular/core").OutputEmitterRef<Event>;
    readonly outPopoverEvent: import("@angular/core").OutputEmitterRef<TYPE_POPOVER_EVENT>;
    readonly outFunctionsControl: import("@angular/core").OutputEmitterRef<IPopoverFunctionControlEvent>;
    private readonly buttonEl;
    constructor();
    ngAfterViewInit(): void;
    protected handlerClick(e: Event): void;
    protected handlerPopoverControlEvent(control: IPopoverFunctionControlEvent): Promise<void>;
    private setClassByType;
    private setClassAndIconLoadingByType;
    private setVariableStyles;
    protected handlerPopoverEvent(event: TYPE_POPOVER_EVENT): Promise<void>;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<LibsUiComponentsButtonsButtonComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<LibsUiComponentsButtonsButtonComponent, "libs_ui-components-buttons-button", never, { "flagMouse": { "alias": "flagMouse"; "required": false; "isSignal": true; }; "type": { "alias": "type"; "required": false; "isSignal": true; }; "buttonCustom": { "alias": "buttonCustom"; "required": false; "isSignal": true; }; "sizeButton": { "alias": "sizeButton"; "required": false; "isSignal": true; }; "label": { "alias": "label"; "required": false; "isSignal": true; }; "disable": { "alias": "disable"; "required": false; "isSignal": true; }; "isPending": { "alias": "isPending"; "required": false; "isSignal": true; }; "imageLeft": { "alias": "imageLeft"; "required": false; "isSignal": true; }; "classInclude": { "alias": "classInclude"; "required": false; "isSignal": true; }; "classIconLeft": { "alias": "classIconLeft"; "required": false; "isSignal": true; }; "classIconRight": { "alias": "classIconRight"; "required": false; "isSignal": true; }; "classLabel": { "alias": "classLabel"; "required": false; "isSignal": true; }; "iconOnlyType": { "alias": "iconOnlyType"; "required": false; "isSignal": true; }; "popover": { "alias": "popover"; "required": false; "isSignal": true; }; "ignoreStopPropagationEvent": { "alias": "ignoreStopPropagationEvent"; "required": false; "isSignal": true; }; "zIndex": { "alias": "zIndex"; "required": false; "isSignal": true; }; "widthLabelPopover": { "alias": "widthLabelPopover"; "required": false; "isSignal": true; }; "styleIconLeft": { "alias": "styleIconLeft"; "required": false; "isSignal": true; }; "styleButton": { "alias": "styleButton"; "required": false; "isSignal": true; }; "ignoreFocusWhenInputTab": { "alias": "ignoreFocusWhenInputTab"; "required": false; "isSignal": true; }; "ignoreSetClickWhenShowPopover": { "alias": "ignoreSetClickWhenShowPopover"; "required": false; "isSignal": true; }; "ignorePointerEvent": { "alias": "ignorePointerEvent"; "required": false; "isSignal": true; }; "isActive": { "alias": "isActive"; "required": false; "isSignal": true; }; "isHandlerEnterDocumentClickButton": { "alias": "isHandlerEnterDocumentClickButton"; "required": false; "isSignal": true; }; }, { "outClick": "outClick"; "outPopoverEvent": "outPopoverEvent"; "outFunctionsControl": "outFunctionsControl"; }, never, never, true, never>;
}
